  MEMBER

  INCLUDE('DPClass.inc')
  INCLUDE('ABERROR.INC'),ONCE
  MAP
    INCLUDE('C55UTIL.INC')
    MODULE('WINDOWS.DLL')
      OpenPrinterA(*CSTRING,LONG,LONG=0),BOOL,PASCAL,RAW
      ClosePrinter(UNSIGNED),BOOL,PASCAL,PROC
      WritePrinter(UNSIGNED,LONG,ULONG,*ULONG),BOOL,PASCAL,RAW
      StartDocPrinterA(UNSIGNED,ULONG,LONG),ULONG,PASCAL
      StartPagePrinter(UNSIGNED),BOOL,PASCAL
      EndDocPrinter(UNSIGNED),BOOL,PASCAL,PROC
      EndPagePrinter(UNSIGNED),BOOL,PASCAL,PROC
    END
  END!MAP

DPClass.init   Procedure(STRING PrinterName, <STRING Linefeed>, <STRING PaperFeed>)
  CODE
  !SELF.PrinterDefaults &= NEW Printer_Defaults
  SELF.PrinterDefaults.DesiredAccess = 0F000Ch !Printer_All_Access
  SELF.PrinterName = CLIP(PrinterName)

  if ~SELF.Open()
    !DISPOSE(SELF.PrinterDefaults)
    !SELF.PrinterDefaults &= NULL
    return(Level:Fatal)
  end!if

  SELF.Driver.Linefeed  = Linefeed
  SELF.Driver.Paperfeed = Paperfeed

  return(level:Benign)

DPClass.Open  procedure
ReturnValue   LONG
  CODE
  ReturnValue = OpenPrinterA(SELF.PrinterName,ADDRESS(SELF.PrinterHandle),ADDRESS(SELF.PrinterDefaults))
  if ReturnValue
    SELF.Opened = true
  end!If
  return(ReturnValue)

DPClass.PrintCode  procedure(STRING ToPrint,<STRING JobName>,BYTE EndChar=0)
Written      ULONG
Result       ULONG
pDocName     CSTRING(80)
pDocType     CSTRING(80)
!gDocInfo     &GROUP  !GROUP(DOCINFO).
!gDocINFO
gDocInfo_1   GROUP(DOCINFO_1).
gDocInfo_2   GROUP(DOCINFO_2).
lpDocInfo    LONG,AUTO
pPrintData   LONG,AUTO
pLengte      ULONG
ReturnValue  LONG
  CODE
  if ~SELF.Opened
    if ~SELF.Open()
      !printer niet geopend!
      return(level:fatal)
    end!If
  end!if

  SELF.PrintData = CLIP(ToPrint)
  pLengte        = len(CLIP(ToPrint)) !niet van de CSTRING want er kunnen CHR(0) in de PrinterCodes zitten!

  case EndChar
    OF Print:NoEndChar
    OF Print:LineFeed
      SELF.PrintData = SELF.PrintData & SELF.Driver.Linefeed
      pLengte   += len(SELF.Driver.Linefeed)
    OF Print:PaperFeed
      SELF.PrintData = SELF.PrintData & SELF.Driver.PaperFeed
      pLengte   += len(SELF.Driver.Paperfeed)
  end!case
  pPrintData = ADDRESS(SELF.PrintData)
  !message('printdata ' & SELF.PrintData & ' pdate: ' & pPrintData )

  pDocName     = CHOOSE(len(cliP(JobName))>0,JobName,'Direct Print Class Job')
  pDocType     = 'RAW'

  case UPPER(SUB(OSVersion(),1,10))
    of 'WINDOWS 98' OROF 'WINDOWS 95'
      !docinfo_2 gebruiken
      gDocINFO_2.lpszDocName  = ADDRESS(pDocName)
      gDocINFO_2.lpszOutput   = 0
      gDocINFO_2.lpszDataType = ADDRESS(pDocType)
      gDocINFO_2.Mode         = 0 !gewoon normaal printen
      gDocINFO_2.JobId        = 0
      lpDocInfo = ADDRESS(gDocINFO_2)
    else
      gDocINFO_1.lpszDocName  = ADDRESS(pDocName)
      gDocINFO_1.lpszOutput   = 0
      gDocINFO_1.lpszDataType = ADDRESS(pDocType)
      lpDocInfo = ADDRESS(gDocINFO_1)
  end!case

  !document starten
  if ~StartDocPrinterA(SELF.PrinterHandle,1,lpDocINfo)
    !document niet gestart
    ClosePrinter(SELF.PrinterHandle)
    SELF.Opened = false
    return(level:notify)
  end!If

  !pagina starten
  if ~StartPagePrinter(SELF.PrinterHandle)
    !pagina niet gestart
    EndDocPrinter(SELF.PrinterHandle)
    ClosePrinter(SELF.PrinterHandle)
    SELF.Opened = false
    return(level:notify)
  end!If

  Written     = ADDRESS(Result)
  !message('PrinterHandle: ' & SELF.PrinterHandle & ' lengte: '  & pLengte)
  ReturnValue = WritePrinter(SELF.PrinterHandle,pPrintDATA,pLengte,Written)

  endPagePrinter(SELF.PrinterHandle)
  endDocPrinter(SELF.PrinterHandle)

  return( ReturnValue ) !CHOOSE(ReturnValue > 0,1,0) )

DPClass.kill    procedure
  CODE
  if SELF.Opened
    ClosePrinter(SELF.PrinterHandle)
  end!If